<?
# Galeras II - DMI-Gal rewrite from scratch
# Module: Objects
# gal-objects.inc 
# Derechos Reservados (c) 2003 Sandino Araico Snchez
# Derechos Reservados (c) 2003 Presidencia de la Repblica
# Copyright (c) 2003 Sandino Araico Snchez All rights reserved
/*
 * --COMIENZA LICENCIA EN ESPAOL MEXICANO-------------------------------------
 * Por ste medio se otroga permiso, libre de cargo, a cualquier persona que
 * obtenga una copia de este software y archivos de documentacin asociados
 * (el "Software"), a utilizar el Software sin restriccin, incluyendo sin 
 * limitacin los derechos de usar, copiar, modificar, unir, publicar, 
 * distribuir y/o vender copias de el Software, y permitir lo mismo a personas 
 * a quienes les sea entregado el software, siempre y cuando los avisos de 
 * Derechos reservados y Copyright que aparecen arriba y ste permiso (en 
 * espaol y en ingls) aparezcan en todas las copias de el Software y que 
 * tanto los avisos de Derechos reservados y Copyright que aparecen arriba como
 * ste permiso (en espaol y en ingls) aparezcan en la documentacin de
 * soporte.
 *
 * ESTE SOFTWARE SE PROVEE "TAL CUAL", SIN NINGUNA GARANTA DE NINGN TIPO,
 * EXPRESA O IMPLCITA, INCLUYENDO PERO NO LIMITNDOSE A LAS GARANTAS DE
 * MERCANTIBILIDAD, ADECUACIN PARA UN PROPSITO EN PARTICULAR Y NO 
 * INFRACCIN DE LOS DERECHOS DE TERCERAS PARTES. EN NINGN MOMENTO EL O LOS 
 * TITULARES DE LOS DERECHOS DE AUTOR Y COPYRIGHT INCLUIDOS EN ESTE AVISO SERN
 * RESPONSABLES POR CUALQUIER RECLAMACIN O POR CUALQUIER DAO ESPECIAL,
 * INDIRECTO O CONSECUENTE, O CUALQUIER DAO QUE RESULTE DE LA PRDIDA DE USO,
 * DATOS O GANANCIAS, YA SEA EN UNA ACCIN DE CONTRATO, NEGLIGENCIA U OTRA 
 * ACCIN TORTUORIA, RESULTANTE DE O EN CONEXIN CON EL USO O DESEMPEO DE
 * ESTE SOFTWARE.
 *
 * Excepto que se incluya en ste aviso, no se debe usar el nombre de ningn 
 * titular de Derechos de autor o Copyright en publicidad o de otra manera 
 * psra promover la venta, uso u otros tratos en este Software sin previa 
 * autorizacin por escrito del titular de Derechos de autor o Copyright.
 * --TERMINA LICENCIA----------------------------------------------------------
 *
 * --BEGIN LICENSE IN US ENGLISH-----------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, and/or sell copies of the Software, and to permit persons
 * to whom the Software is furnished to do so, provided that the above
 * copyright and "Derechos reservados" notices and this permission notice  
 * (in spanish and english) appear in all copies of the Software and that both 
 * the above copyright and "Derechos reservados" notices and this permission 
 * notice (in spanish and english) appear in supporting documentation.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
 * OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT AND "DERECHOS DE 
 * AUTOR" HOLDER OR HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR 
 * ANY SPECIAL INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER 
 * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF 
 * CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 * Except as contained in this notice, the name of a copyright or "Derechos de
 * autor" holder shall not be used in advertising or otherwise to promote the
 * sale, use or other dealings in this Software without prior written 
 * authorization of the copyright or "Derechos de autor" holder.
 * --END LICENSE---------------------------------------------------------------
 */
 
# Changelog: 
# 2003-02-01 Sandino Araico Snchez - Object-management functions
# 2003-02-02 Sandino Araico Snchez - Image attributes into object
# 2003-02-04 Sandino Araico Snchez - Moved thumbnail functions to gal-thumbs
# 2003-02-05 Sandino Araico Snchez - Bugfixes

if(!defined('__GAL_OBJECTS__'))
{
	define('__GAL_OBJECTS__',1);
#---------------------------------------------------------------------
include __HOPP_INCLUDE_PATH.'cache.inc';
include __HOPP_INCLUDE_PATH.'fs.inc';
#---------------------------------------------------------------------
function gal_get_objects_from_dir($dir)
{
	$param_string=":GALERIAS-II:gal_get_objects_from_dir($dir):";	
	$objects=h_cache_get_object($param_string, __GAL_CACHE_TTL, 1, 'object', __GAL_THUMBS_DIR);
	if(!is_array($objects))
	{
		$objects=h_fs_get_file_objects_from_dir($dir,1,'gal_get_extra_object_from_file');
		h_cache_put_object($param_string, $objects, 'object', __GAL_THUMBS_DIR);
	}
	return $objects;
}

function gal_get_sort_objects($dir, $objects,$sort_by='FILE',$reverse=1,$flags=SORT_REGULAR)
{
	if(!is_array($objects))
		return;
	// $objects identification should be optimized	
	$param_string=":GALERIAS-II:gal_get_sort_objects($dir,$sort_by,$reverse,$flags):";	
	$sort_objects=h_cache_get_object($param_string, __GAL_CACHE_TTL, 1, 'object', __GAL_THUMBS_DIR);
	if(!is_array($sort_objects))
	{
		foreach($objects as $key => $object)
		{
			if($object[$sort_by])
				$sort_objects[$key]=$object[$sort_by];
		}
		if(!is_array($sort_objects))
		{
			s_log_error('$sort_objects is not an array');
			return;
		}	
		if($reverse)
			arsort($sort_objects, $flags);
		else	
			asort($sort_objects, $flags);
		h_cache_put_object($param_string, $sort_objects, 'object', __GAL_THUMBS_DIR);
	}		
	return $sort_objects;
	
}
#---------------------------------------------------------------------
function gal_get_extra_object_from_file($file, $object, $detail=0)
{
	if($detail)
		$img_info = @getImageSize($file, &$img_detail);
	else	
		$img_info = @getImageSize($file);
	if(is_array($img_info))
	{
		$object['IMG_W']=$img_info[0];
		$object['IMG_H']=$img_info[1];
		$object['IMG_TYPE']=$img_info[2];
		$object['IMG_SIZE']=$img_info[3];
		if($detail>=2)
		{
			if(!empty($img_info['bits']))
				$object['IMG_BITS']=$img_info['bits'];
			if(!empty($img_info['channels']))	
				$object['IMG_CHANNELS']=$img_info['channels'];
			if(is_array($img_detail))	
			{
				foreach($img_detail as $key => $value)
				{
					$img_key="IMG_$key";
					$object[$img_key]=$value;
				}
			}
		}
		if(empty($img_info['mime']))
			$img_info['mime']=image_type_to_mime_type($object['IMG_TYPE']);
		if(!empty($img_info['mime']))
		{
			s_log("Redefining Image MIME type: ".$object['MIME'].'--->'.$img_info['mime'],0,0,2);
			$object['MIME']=$img_info['mime'];
		}	
	}
	else
		s_log_error("$file: No Image Info available");
	$object['IMG_TITLE']=gal_get_image_title($object);
	return $object;
}

function gal_get_image_title($object)
{
	if(!empty($object['WO_EXT']))
	{
		$text_file=$object['DIR'].'/'.$object['WO_EXT'].'.txt';
		s_log("text_file: $text_file",0,0,2);
		if(file_exists($text_file))
		{
			$file=fopen($text_file,'r');
			if($file)
			{
				$text=fread($file,1024);
				fclose($file);
				#s_log("Using text file contents: $text",0,0,2);
			}
		}
		if(empty($text))
			$text=str_replace("_", " ", ($object['WO_EXT']));
	}	
	if(empty($text))
		$text=str_replace("_", " ", ($object['FILE']));
	s_log("text: $text",0,0,3);	
	//return  nl2br(htmlentities($text)); // File title should be returned as is
	return $text;

}

#---------------------------------------------------------------------
} //__GAL_OBJECTS__
?>
